package Proxmox::RS::Subscription;

require DynaLoader;

sub autodirs { map { "$_/auto" } @INC; }
sub envdirs { grep { length($_) } split(/:+/, $ENV{LD_LIBRARY_PATH} // '') }

sub bootstrap {
    my ($pkg) = @_;
    my ($mod_name) = ('pve_rs');
    my $bootstrap_name = 'boot_' . ($pkg =~ s/::/__/gr);

    my @dirs = map { "-L$_" } (envdirs(), autodirs());
    my $mod_file = DynaLoader::dl_findfile(@dirs, $mod_name);
    die "failed to locate shared library for '$pkg' (lib${mod_name}.so)\n" if !$mod_file;

    my $lib = DynaLoader::dl_load_file($mod_file)
        or die "failed to load library '$mod_file'\n";

    my $sym  = DynaLoader::dl_find_symbol($lib, $bootstrap_name);
    die "failed to locate '$bootstrap_name'\n" if !defined $sym;
    my $boot = DynaLoader::dl_install_xsub($bootstrap_name, $sym, "src/FIXME.rs");
    $boot->();
}

__PACKAGE__->bootstrap;

1;
